! Subs for energy with water (1 parameter)
! Eshel Faraggi 01/2012 (c)

module temp
  integer naatyp
  integer i, j, k, n, nres, ipo
  double precision tmp
  character*300 pdbfl, depfl
  character*3, allocatable :: aatom(:)
  integer, allocatable :: iaa(:)
  double precision, allocatable :: pdat(:,:)
end module
!_______________________________________________________________________
!--
      subroutine initall()
      use temp
      implicit none
      integer iaa2i, nargs,icrd
      double precision xc(3)
      character tc1, tc2*10, tc3*10, arg*300, tmpfl*300
      
      !read command line
      pdbfl = ""
      depfl = "amino_acids.types"
      nargs=iargc()
      if (nargs.ge.1) then
        icrd = 1
!       Switches:
        do while (icrd.le.nargs)
          call getarg(icrd,arg)
          if (arg.eq."-dp") then                !build db
            call getarg(icrd+1,tmpfl)
            pdbfl = trim(tmpfl)
            !write(*,'(1x,130(A),1x)',advance='no') trim(arg), " ", trim(tmpfl)
          elseif (arg.eq."-t") then          !types file
            call getarg(icrd+1,tmpfl)
            depfl = trim(tmpfl)
            !write(*,'(1x,130(A),1x)',advance='no') trim(arg), " ", trim(tmpfl)
          elseif (arg.eq."-h") then
            call printhelp()
            stop
          endif
          icrd = icrd + 1
        enddo
      else
            call printhelp()
            stop
      endif
      
      open(22,file=depfl,status='old')
      i = 0
      do while(i.ge.0)
        i = i + 1
        read(22,*,end=101)
      enddo
101   continue
      naatyp = i
      allocate( aatom(naatyp) )
      rewind(22)
      i = 0
      do while(i.ge.0)
        i = i + 1
        read(22,*,end=111) aatom(i)
      enddo
      close(22)
111   continue

      if (pdbfl.ne."") then
        nres = 20000
        k = 1
        allocate( iaa(nres), pdat(3,nres) )
        !read file
        open(unit=22,file=pdbfl,status='old')
        i = 1
        do while(i.gt.0)
          read(22,*,end=121) arg
          if (arg.eq."ATOM") then
            backspace(22)
            read(22,'(A13,A3,A1,A3,A10,D8.3,D8.3,D8.3)',end=121) arg, tc2, arg, tc3, tc1, (xc(n),n=1,3)
            if (tc3.eq."GLY") then
              if (tc2.eq."CA") then
                do n=1,3
                  pdat(n,i) = 1.d0 * xc(n)
                enddo
                iaa(i) = iaa2i(tc3)
                i = i + 1
              endif
            else
              if (tc2.eq."CB") then
                do n=1,3
                  pdat(n,i) = 1.d0 * xc(n)
                enddo
                iaa(i) = iaa2i(tc3)
                i = i + 1
              endif
            endif
          endif
        enddo
121     continue
        close(22)
        nres = i - 1
        ipo = 1
        if (i.le.1) then
          !write(0,*) "Aborting, nres problem."
          stop
        endif

        call e2rr(nres,pdat(1,ipo),iaa(ipo))
      endif
      
      end
!_______________________________________________________________________
!--
      subroutine printhelp()
      use temp
      implicit none
      
      print*, "Distance matrix . Step 1+2"
      print*, "Eshel Faraggi, efaraggi@gmail.com"
      print*, "You Must Obtain License from above address to USE this program"
      write(*,*) " prints parmaters for distance to water"
      print*, "Options:"

      write(*,'(A10,3x,A30,10x,A20)') "Switch","Description", "Default"
      write(*,'(A10,3x,A30,10x,A20)') "-dp","pdbfile", "NONE"
      write(*,'(A10,3x,A30,10x,A120)') "-t","typefile", depfl
      write(*,'(A10,3x,A30,10x,A20)') "-h","print_this_help"
      write(*,*) 
      write(*,*) "Program to calculate inverse distance inputs to NN."

      end
!_______________________________________________________________________
!--
      subroutine e2rr(ivsize,v,jaa)
      use temp
      implicit none
      integer ivsize, jaa(ivsize)
      double precision v(3,ivsize), qpar(naatyp,naatyp), qpar3(naatyp,naatyp)
      integer iqpar(naatyp,naatyp)

      do i=1,naatyp
        do j=1,naatyp
          qpar(i,j) = 0.d0
          qpar3(i,j) = 0.d0
          iqpar(i,j) = 0
        enddo
      enddo
      do i=1,ivsize-1
        do j=i+1,ivsize
          tmp = 0.d0
          do n=1,3
            tmp = tmp + (v(n,i)-v(n,j))*(v(n,i)-v(n,j))
          enddo
          tmp = dsqrt(tmp)
          if (tmp.gt.0.d0) then
            qpar(jaa(i),jaa(j)) = qpar(jaa(i),jaa(j)) + 1.d0 / tmp
            qpar3(jaa(i),jaa(j)) = qpar3(jaa(i),jaa(j)) + 1.d0/ (tmp*tmp*tmp)
            iqpar(jaa(i),jaa(j)) = iqpar(jaa(i),jaa(j)) + 1
          else
            !write(0,*) "Aborting, weird zero distance between", i,j
            stop
          endif
        enddo
      enddo
      tmp = (1.d0*ivsize)**(1.d0/3)
      
      do i=1,naatyp
        do j=1,naatyp
          write(*,*) qpar(i,j)/tmp, qpar3(i,j)/tmp, iqpar(i,j)/(1.d0*ivsize)
        enddo
      enddo

      end
!_______________________________________________________________________
!--
      integer function iaa2i(caa)
      use temp
      implicit none
      integer ii
      character caa*10
      
      iaa2i = naatyp
      do ii=1,naatyp - 1
        if (caa.eq.aatom(ii)) iaa2i = ii
      enddo
      if (iaa2i.eq.naatyp) then
        write(0,*) "Unknown type ", caa
!        stop
      endif
      
      end
!_______________________________________________________________________
